package com.yaros.almacen.dao;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Optional;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.yaros.almacen.config.AppConfig;
import com.yaros.almacen.model.Product;

@Repository
public class ProductDaoImplMemory implements ProductDao {
	
	public List<Product> peliculas = new ArrayList<>();
	
	@Autowired
	private AppConfig appConfig;
	@PostConstruct
	public void init() {
		peliculas = UtilProductFileReader.readFile(appConfig.getFile(), appConfig.getSeparator(), appConfig.getListSeparator());
	}

	public Product findById(long id) {
		// TODO Auto-generated method stub
		// @formatter:off
		Optional<Product> result = peliculas.stream().filter(f -> f.getId() == id).findFirst();
		// @formatter:on
		return result.orElse(null);
	}

	public Collection<Product> findAll() {
		// TODO Auto-generated method stub
		return peliculas;
	}

	public void insert(Product product) {
		// TODO Auto-generated method stub
		peliculas.add(product);
	}

	public void edit(Product product) {
		// TODO Auto-generated method stub
		int index = getIndexOf(product.getId());
		if(index != -1)
			peliculas.set(index, product);
	}

	public void delete(long id) {
		// TODO Auto-generated method stub
		int index = getIndexOf(id);
		if(index != -1)
			peliculas.remove(index);
	}
	
	private int getIndexOf(long id) {
		boolean encontrado = false;
		int index = 0;
		while(!encontrado && index < peliculas.size()) {
			if(peliculas.get(index).getId() == id)
				encontrado = true;
			else
				index++;
		}
		return (encontrado) ? index : -1;
	}
}
