package com.yaros.almacen.model;

import java.util.List;
import java.util.Objects;

public class Product {
	private long id;
	private String name;
	private String manufacturer;
	private String shelf;
	private String weight;
	private String size;
	private int num;
	private List<String> notes;
	
	public Product() {
		
	}

	public Product(long id, String name, String manufacturer, String shelf, String weight, String size, int num,
			List<String> notes) {
		super();
		this.id = id;
		this.name = name;
		this.manufacturer = manufacturer;
		this.shelf = shelf;
		this.weight = weight;
		this.size = size;
		this.num = num;
		this.notes = notes;
	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getManufacturer() {
		return manufacturer;
	}

	public void setManufacturer(String manufacturer) {
		this.manufacturer = manufacturer;
	}

	public String getShelf() {
		return shelf;
	}

	public void setShelf(String shelf) {
		this.shelf = shelf;
	}

	public String getWeight() {
		return weight;
	}

	public void setWeight(String weight) {
		this.weight = weight;
	}

	public String getSize() {
		return size;
	}

	public void setSize(String size) {
		this.size = size;
	}

	public int getNum() {
		return num;
	}

	public void setNum(int num) {
		this.num = num;
	}

	public List<String> getNotes() {
		return notes;
	}

	public void setNotes(List<String> notes) {
		this.notes = notes;
	}

	@Override
	public int hashCode() {
		return Objects.hash(id, manufacturer, name, notes, num, shelf, size, weight);
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Product other = (Product) obj;
		return id == other.id && Objects.equals(manufacturer, other.manufacturer) && Objects.equals(name, other.name)
				&& Objects.equals(notes, other.notes) && num == other.num && Objects.equals(shelf, other.shelf)
				&& Objects.equals(size, other.size) && Objects.equals(weight, other.weight);
	}

	@Override
	public String toString() {
		return "Producto [id=" + id + ", name=" + name + ", manufacturer=" + manufacturer + ", shelf=" + shelf
				+ ", weight=" + weight + ", size=" + size + ", num=" + num + ", notes=" + notes + "]";
	}
	
	
}
