package com.yaros.almacen.service;

import java.time.LocalDate;
import java.util.Arrays;
import java.util.Collection;
import java.util.function.Predicate;
import java.util.stream.Collectors;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yaros.almacen.dao.ProductDao;
import com.yaros.almacen.model.Product;

@Service
public class ProductQuearyServiceImpl implements ProductQueryService {
	@Autowired
	private ProductDao dao;
	private Predicate<Product> predicate;
	
	//DE DONDE COÑO SALE EL POSTCONSTRUCT
	@PostConstruct
	public void init() {
		predicate = null;
	}

	@Override
	public Collection<Product> exec() {
		// @formatter:off
		return dao.findAll().stream().filter(predicate).collect(Collectors.toList());
		// @formatter:on
	}
	
	/*@Override
	public ProductQueryService anyId(String... id) {
		Predicate<Product> pAnyGenere = (product -> Arrays.stream(id).anyMatch(product.getId()::contains));
		predicate = (predicate == null) ? pAnyGenere : predicate.and(pAnyGenere);
		return this;
	}*/

	@Override
	public ProductQueryService anyManufacturer(String... manufacturers) {
		Predicate<Product> pAnyGenere = (product -> Arrays.stream(manufacturers).anyMatch(product.getManufacturer()::contains));
		predicate = (predicate == null) ? pAnyGenere : predicate.and(pAnyGenere);
		return this;
	}

	

	@Override
	public ProductQueryService nameContains(String name) {
		Predicate<Product> pTitleContains = (product -> product.getName().toLowerCase().contains(name.toLowerCase()));
		predicate = (predicate == null) ? pTitleContains : predicate.and(pTitleContains);
		return this;
	}

	@Override
	public ProductQueryService anyNote(String... notes) {
		Predicate<Product> pAllGeneres = (product -> Arrays.stream(notes).allMatch(product.getNotes()::contains));
		predicate = (predicate == null) ? pAllGeneres : predicate.and(pAllGeneres);
		return this;
	}

}